## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 17;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

Name:           picocli
Version:        4.6.1
Release:        %autorelease
Summary:        Java command line parser with both an annotations API and a programmatic API
License:        ASL 2.0
URL:            https://github.com/remkop/picocli
Source0:        %{url}/archive/v%{version}.tar.gz
Source1:        https://repo1.maven.org/maven2/info/picocli/%{name}/%{version}/%{name}-%{version}.pom
Source2:        https://repo1.maven.org/maven2/info/picocli/%{name}-codegen/%{version}/%{name}-codegen-%{version}.pom
Source3:        https://repo1.maven.org/maven2/info/picocli/%{name}-shell-jline2/%{version}/%{name}-shell-jline2-%{version}.pom
# Upstream:
#  - manifest entry should not require groovy
Patch0:         981df04ba1b15f3ce052273917cf5779032e672f.patch
BuildArch:      noarch

BuildRequires:  maven-local
BuildRequires:  mvn(biz.aQute.bnd:bnd-maven-plugin)

%description
Picocli is a modern library and framework, written in Java, that contains both
an annotations API and a programmatic API. It features usage help with ANSI
colors and styles, TAB auto-completion and nested sub-commands. In a single
file, so you can include it in source form. This lets users run picocli-based
applications without requiring picocli as an external dependency.

%package -n %{name}-codegen
Summary:        Tools to generate documentation, configuration, source code from a picocli model

%description -n %{name}-codegen
The picocli-codegen (Picocli Code Generation) module contains tools for
generating configuration files and documentation for picocli-based applications.

This module also includes an annotation processor that can build a model from
the picocli annotations at compile time rather than at runtime.

The annotation processor allows many of the tools to be invoked automatically as
part of the build without configuration. If a tool does not have an annotation
processor wrapper (yet), it can be invoked on the command line, and can be
scripted to be invoked automatically as part of building your project.

%package -n %{name}-shell-jline2
Summary:        Easily build interactive shell applications with JLine 2 and picocli
BuildRequires:  mvn(jline:jline) >= 2.14.6

%description -n %{name}-shell-jline2
Picocli Shell JLine2 contains components and documentation for building
interactive shell command line applications with JLine 2 and picocli.

JLine and picocli complement each other very well and have little or none
functional overlap.

JLine provides interactive shell functionality but has no built-in command line
parsing functionality. What it does provide is a tokenizer for splitting a
single command line String into an array of command line argument Strings.

Given an array of Strings, picocli can execute a command or subcommand.
Combining these two libraries makes it easy to build powerful interactive shell
applications.

%javadoc_package

%prep
%autosetup -p1
# note:
# picocli is a gradle project, we need to transform it to maven.
# here, we create a parent pom according to maven project aggregation. (see 
# https://maven.apache.org/guides/introduction/introduction-to-the-pom.html#project-aggregation)

# remove bundled jar/class files from the source
find -type f \( -name \*.jar -o -name \*.class \) -delete

# create directory for picocli
mkdir %{name}

# move picocli source code
# and its bnd.bnd
mv src/ bnd.bnd %{name}

# place pom.xml from maven repo.
# picocli pom
cp -p %{SOURCE1} %{name}/pom.xml

# picocli-codegen pom
cp -p %{SOURCE2} %{name}-codegen/pom.xml

# picocli-shell-jline2 pom
cp -p %{SOURCE3} %{name}-shell-jline2/pom.xml

# create parent from the unused pom
# set the artifact id
%pom_xpath_set pom:project/pom:artifactId %{name}-parent

# set the name (optional: useful for debugging)
%pom_xpath_set pom:project/pom:name %{name}-parent

# set to current version
%pom_xpath_set pom:project/pom:version %{version}

# set the packaging
%pom_xpath_set pom:project/pom:packaging pom

# add modules
%pom_xpath_inject pom:project '
<modules>
  <module>%{name}</module>
  <module>%{name}-codegen</module>
  <module>%{name}-shell-jline2</module>
</modules>'

# module picocli: set the name to picocli
%pom_xpath_set pom:project/pom:name %{name} %{name}

# module picocli: add manifest plugin
%pom_add_plugin biz.aQute.bnd:bnd-maven-plugin %{name} '
<executions>
  <execution>
    <goals>
      <goal>bnd-process</goal>
    </goals>
  </execution>
</executions>
<configuration>
  <bndfile>bnd.bnd</bndfile>
  <bnd>
    Specification-Title: picocli
    Specification-Vendor: Remko Popma
    Implementation-Title: picocli
    Implementation-Vendor: Remko Popma
    Main-Class: picocli.AutoComplete
  </bnd>
</configuration>'

# module picocli-codegen: don't perform annotation processing
%pom_add_plugin org.apache.maven.plugins:maven-compiler-plugin %{name}-codegen '
<configuration>
  <proc>none</proc>
</configuration>'

# module picocli-codegen: add manifest plugin
%pom_add_plugin biz.aQute.bnd:bnd-maven-plugin %{name}-codegen '
<executions>
  <execution>
    <goals>
      <goal>bnd-process</goal>
    </goals>
  </execution>
</executions>
<configuration>
  <bnd>
    Specification-Title: Picocli Code Generation
    Specification-Vendor: Remko Popma
    Implementation-Title: Picocli Code Generation
    Implementation-Vendor: Remko Popma
    Automatic-Module-Name: info.picocli.codegen
  </bnd>
</configuration>'

# module picocli-shell-jline2: add manifest plugin
%pom_add_plugin biz.aQute.bnd:bnd-maven-plugin %{name}-shell-jline2 '
<executions>
  <execution>
    <goals>
      <goal>bnd-process</goal>
    </goals>
  </execution>
</executions>
<configuration>
  <bnd>
    Specification-Title: Picocli Shell JLine2
    Specification-Vendor: Remko Popma
    Implementation-Title: Picocli Shell JLine2
    Implementation-Vendor: Remko Popma
    Automatic-Module-Name: info.picocli.shell.jline2
  </bnd>
</configuration>'

# all modules: add manifest
%pom_add_plugin org.apache.maven.plugins:maven-jar-plugin %{name} %{name}-codegen %{name}-shell-jline2 '
<configuration>
  <archive>
    <manifestFile>${project.build.outputDirectory}/META-INF/MANIFEST.MF</manifestFile>
  </archive>
</configuration>'

# don't install parent pom
%mvn_package :picocli-parent __noinstall

%build
# build in jdk8
%mvn_build -s -f -- -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8

%install
%mvn_install

%files -n %{name} -f .mfiles-%{name}
%license LICENSE
%doc README.md RELEASE-NOTES.md

%files -n %{name}-codegen -f .mfiles-%{name}-codegen
%license LICENSE
%doc %{name}-codegen/README.adoc

%files -n %{name}-shell-jline2 -f .mfiles-%{name}-shell-jline2
%license LICENSE
%doc %{name}-shell-jline2/README.md

%changelog
* Sun Sep 12 2021 Didik Supriadi <didiksupriadi41@gmail.com> 4.6.1-17
- RPMAUTOSPEC: unresolvable merge
